#!/usr/bin/env python

from httplib import HTTPS
from httpposter import postbase
from urllib import urlencode
from lxml.html import soupparser

class bugzilla(postbase):

    def __init__(self, user, passwd):

        self.h = HTTPS('bugs.webkit.org')
        self.h.set_debuglevel(3)

        self.sc = {}

        self.user = user
        self.passwd = passwd

        self.attribs = {}

        # first connect - login
        args = { 'Bugzilla_restrictlogin': '0',
                 'GoAheadAndLogin': ['Log in', '1'],
                 'log_in': 'Log in',
                 'Bugzilla_login': user,
                 'Bugzilla_password': passwd
                 }

        print urlencode(args)

        self.post('/index.cgi', urlencode(args, doseq=True))
        status, reason, headers = self.h.getreply()

        print 'status =', status, type(status)
        print 'reason =', reason
        session_c = self.get_cookies(headers)
        for c in session_c:
            self.sc[c] = session_c[c]

        return

        # first connect - get cookies
        self.h.putrequest('GET', '/index.cgi')
        self.h.add_cookies(self.sc)
        self.h.endheaders()
        status, reason, headers = self.h.getreply()
        ck = headers.getheaders('Set-Cookie')
        print 'status =', status
        print 'reason =', reason
        print 'headers =', ck

        session_c = self.get_cookies(headers)
        for c in session_c:
            self.sc[c] = session_c[c]

    def post_attachment(self,
                        bug, filename, patch,
                        description, review='X'):
            
        bug = str(bug)

        # first connect - get cookies
        self.h.putrequest('GET', '/attachment.cgi?bugid=%s&action=enter' % bug)
        self.add_cookies(self.sc)
        self.h.endheaders()
        status, reason, headers = self.h.getreply()
        ck = headers.getheaders('Set-Cookie')
        print 'status =', status
        print 'reason =', reason
        print 'headers =', ck

        session_c = self.get_cookies(headers)
        for c in session_c:
            self.sc[c] = session_c[c]

        txt = self.h.file.read()
        #print txt

        doc = soupparser.fromstring(txt)
        form = doc.forms[1]
        print form.fields.keys()
        token = form.fields['token']

        args = [( 'bugid', bug),
                (   'action', 'insert' ),
                (   'token', token ),
                (   'description', description ),
                (   'ispatch', '1' ),
                (   'flag_type-1', review ),
                (   'flag_type-3', 'X' ),
                  ]

        files = [('data', filename, patch)]

        self.post_multipart('/attachment.cgi', args, files)
        status, reason, headers = self.h.getreply()

        print 'status =', status
        print 'reason =', reason

        f = self.h.getfile()
        if f:
            self.response = f.read()


